import pygame
import sys
from math import *
dim=4

"""
#hypercube
points=[[2*((x >> i)%2)-1 for i in xrange(dim)] for x in xrange(2**dim)]
lines=[]
for i in xrange(len(points)):
    for j in xrange(i):
        if sum(points[i][k]!=points[j][k] for k in xrange(dim))==1:
            lines.append((i,j))
"""

"""
#simplex
dim+=1
points=[[-1.0/dim]*dim for x in xrange(dim)]
for i in xrange(dim):
    points[i][i]=1
lines=[(x,y) for x in xrange(len(points)) for y in xrange(i)]
"""

"""
#hypercube dual
points=[[0 for i in xrange(dim)] for x in xrange(2*dim)]
for i in xrange(dim):
    points[i][i]=1
for i in xrange(dim):
    points[i+dim][i]=-1

lines=[]
for i in xrange(len(points)):
    for j in xrange(i):
        if not i-j==dim:
            lines.append((i,j))
"""

baset=pi/180
SW,SH=640,480
scx=scy=100
cx=cy=250

"""
polyn=10
polyr=1
polyoffset=0
for k in xrange(self.polyn):
    init=polyr*cexp(2*pi*(k+polyoffset)*1j/polyn)
    final=polyr*cexp(2*pi*(k+polyoffset+1)*1j/polyn)
    polygon.append((c2t(init),c2t(final)))
"""

def c2t(c):
    return (c.real,c.imag)

def proj(p):
    return (scx*p[0]+cx,scy*p[1]+cy)

def twodrot(p,theta):
    return [cos(theta)*p[0]-sin(theta)*p[1],sin(theta)*p[0]+cos(theta)*p[1]]

def rot(p,axis=(0,1),theta=baset):
    rotd=twodrot((p[axis[0]],p[axis[1]]),theta)
    #print p
    #print p[:axis[0]] ,(rotd[0],) ,p[axis(0)+1:axis(1)] ,(rotd[1],), p[axis(1)+1:]
    newp=p[:axis[0]]+[rotd[0]]+p[axis[0]+1:axis[1]]+[rotd[1]]+p[axis[1]+1:]
    return newp


pygame.init()
screen = pygame.display.set_mode((SW, SH),pygame.DOUBLEBUF)
col=([255,255,255])

c = pygame.time.Clock()
last_fps = 0
while 1:
    c.tick(30)
    if pygame.time.get_ticks() - last_fps > 1000:
        print "FPS: ", c.get_fps()
        last_fps = pygame.time.get_ticks()

    for event in pygame.event.get():
        if event.type == pygame.QUIT:
            sys.exit(0)
        elif event.type == pygame.KEYDOWN:
            if event.key in (pygame.K_ESCAPE, pygame.K_q):
                sys.exit(0)

    for i in xrange(len(points)):
        points[i]=rot(points[i],(0,1),baset)
        points[i]=rot(points[i],(1,2),2*baset)
        points[i]=rot(points[i],(2,3),2.5*baset)
        points[i]=rot(points[i],(0,3),2*baset)
        points[i]=rot(points[i],(0,2),0.5*baset)

    screen.fill([0,0,0])
    for l in lines:
        pygame.draw.line(screen,col,proj(points[l[0]]),proj(points[l[1]]))
    pygame.display.flip()
